      SUBROUTINE  ALFTOK (STRING,LENSTR,FIRST,NEXT)
C     (ALPHANUMERIC TOKEN)
C     Beginning  at  byte  "FIRST"   in  STRING(*),  isolate   an
C     alphanumeric token ending at byte "NEXT-1".  A valid  token
C     is found if "NEXT" .GT.  "FIRST" on return, and an  invalid
C     one if "NEXT" .EQ. "FIRST".   The character in byte  "NEXT"
C     of STRING is guaranteed not to be alphabetic or numeric  on
C     return, unless it  is beyond  the end of  the string.   The
C     token length is given by "NEXT"-"FIRST".  "FIRST" is  never
C     modified.
C     (17-AUG-80)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             DECDIG,      LETTER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ACHAR,       NEXT,        TOKEN
C
      INTEGER             ACHAR,       FIRST,       IARG,        LENSTR
      INTEGER             NEXT,        STRING(1)
      LOGICAL             TOKEN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a decimal digit.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a letter.
C
      LETTER(IARG) = (ARZ .LE. IARG) .AND. (IARG .LE. ZRZ)
C
      ACHAR = CHGET3(STRING,FIRST)
      TOKEN = LETTER(ACHAR)
      IF (.NOT.(TOKEN)) GO TO 20001
      NEXT = FIRST + 1
20004 IF (.NOT.(TOKEN .AND. (NEXT .LE. LENSTR))) GO TO 20005
      ACHAR = CHGET3(STRING,NEXT)
      TOKEN = LETTER(ACHAR) .OR. DECDIG(ACHAR)
      IF (TOKEN) NEXT = NEXT + 1
      GO TO 20004
20005 GO TO 20002
20001 NEXT = FIRST
20002 CONTINUE
C
20003 RETURN
      END
